<?php

namespace CreoCode\ContaoColumns\Component\ContentElement;

use Contao\ContentElement;
use Contao\FrontendTemplate;
use Contao\System;
use Contao\BackendTemplate;

use CreoCode\ContaoColumns\Helper\Helper;

class ColsEnd extends ContentElement
{

	/**
	 * Template
	 * @var string
	 */
	protected $strTemplate = 'ce_colsEnd';

	/**
	 * Set-Type
	 */
	protected $strSet;

	/**
	 * Display a wildcard in the back end
	 * @return string
	 */
	public function generate() {

        $backendColumnView = false;
        if (isset($GLOBALS['_tmp_columns_backend_view']) && $GLOBALS['_tmp_columns_backend_view']) {
            $backendColumnView = true;
        }

        if (Helper::isBackend() && !$backendColumnView) {
            $this->Template = new BackendTemplate('be_column_element');
            $this->Template->setColor = '#'.$this->column_color;
            $this->Template->colsetTitle = $GLOBALS['TL_LANG']['MSC']['colsEnd'];
            $this->Template->colsetSubtitle = '<span class="count">'.$GLOBALS['TL_LANG']['MSC']['cols'].': '.$this->column_amount.'</span> | <span class="name">'.$GLOBALS['TL_LANG']['MSC']['name'].': '.$this->column_name.'</span>';
            $this->Template->type = $this->type;
            $this->Template->id = $this->id;
            $this->Template->backendColumnView = $backendColumnView;

            return $this->Template->parse();
        }

        return parent::generate();
	}

	/**
	 * Generate content element
	 * @return string
	 */
	protected function compile() {
        $backendColumnView = false;

        if (isset($GLOBALS['_tmp_columns_backend_view']) && $GLOBALS['_tmp_columns_backend_view']) {
            $this->strTemplate = 'be_colsEnd';
            $backendColumnView = true;
        }
        $this->Template = new FrontendTemplate($this->strTemplate);
        $this->Template->backendColumnView = $backendColumnView;

        // set id's
        $this->Template->id = $this->id;
        $this->Template->pid = $this->pid;
        $this->Template->column_parent = $this->column_parent;
        $this->Template->sorting = $this->sorting;

	}

}
