<?php

namespace CreoCode\ContaoColumns\Listener;

/**
 * Class Columns provides helper methods for handling the data container and generating the dynamic column set container
 */
class Columns
{

	/**
	 * store container so it has not be regenerated for every column set part
	 * @var array
	 */
	protected static $container = array();

	/**
	 * create a MCW row for each column
	 *
	 * @param string $value deseriazable value, for getting an array
	 * @param $mcw multi column wizard or DC_Table
	 * @return mixed
	 */
	public function createColumns($value, $mcw)
	{

		$columns = (int) $mcw->activeRecord->column_amount;
		$value = unserialize($value);

		if(!$value) {
			$count = 0;
		} else {
			$count = count($value);
		}

		// initialize columns
		if($count == 0) {
			for($i= 0; $i < $columns; $i++) {
				$value[$i]['width'] = floor(12/$columns);
			}
		}
		// reduce columns if necessary
		elseif($count > $columns) {
			$count = count($value) - $columns;

			for($i=0; $i < $count; $i++) {
				array_pop($value);
			}
		}

		// make sure that column numbers has not changed
		else {
			for($i= 0; $i < ($columns - $count); $i++) {
				$value[$i+$count]['width'] = floor(12/$columns);
			}
		}

		return $value;
	}

}
