<?php

namespace CreoCode\ContaoColumns\Listener\Dca;
use Contao\DataContainer;
use Contao\Database;
use Contao\Input;

use CreoCode\ContaoColumns\Helper\Helper;

/**
 * ContentDataContainer helper class.
 */
class FormListener
{

    	/*
    	 * Create the palette for the startelement
    	 */
    	public function createPalette(DataContainer $dataContainer)
    	{
            // Load css & js files
            if (Helper::isBackend()) {
                $GLOBALS['TL_CSS'][] = 'bundles/contaocolumns/css/flexbox/flexbox.scss|static';
                $GLOBALS['TL_CSS'][] = 'bundles/contaocolumns/css/backend.css|static';
                $GLOBALS['TL_JAVASCRIPT'][] = 'bundles/contaocolumns/js/backend.js|async';
            }
			
            $this->Database = Database::getInstance();

            $objModule = $this->Database->prepare("SELECT column_sizes,column_usecustomgap FROM tl_form_field WHERE id=?")
                                    ->limit(1)
                                    ->execute($dataContainer->id);

			if(!$objModule || is_null($objModule->column_sizes)) {
				return;
			}
			
			$sizes = array_merge(unserialize($objModule->column_sizes));
			$colSetSizes = '';

    		$sizes = array_merge(unserialize($objModule->column_sizes, true));
            $colSetSizes = '';

    		foreach($sizes as $size) {
    			$colSetSizes .= ',columns_' . $size;
    		}

    		$GLOBALS['TL_DCA']['tl_form_field']['palettes']['formColsStart'] = str_replace (
    		    'column_sizes',
    		    'column_sizes'.$colSetSizes,
    		    $GLOBALS['TL_DCA']['tl_form_field']['palettes']['formColsStart']
    		);

            if ($objModule->column_usecustomgap) {
                $GLOBALS['TL_DCA']['tl_form_field']['palettes']['formColsStart'] = str_replace (
                    'column_usecustomgap',
                    'column_usecustomgap,column_gap,column_containermarginhorizontal,column_containermarginvertical',
                    $GLOBALS['TL_DCA']['tl_form_field']['palettes']['formColsStart']
                );
            }

    	}


    	/**
    	 * Autogenerate an name for the colset if it has not been set yet
    	 * @param mixed
    	 * @param object
    	 * @return string
    	 */
    	public function setColsetName($varValue, DataContainer $dc)	{
    		$autoName = false;

    		// Generate alias if there is none
    		if (!strlen($varValue))
    		{
    			$autoName = true;
    			$varValue = 'cols.' . $dc->id;
    		}

    		return $varValue;
    	}

    	/**
    	 * Write the other Sets
    	 * @param object
    	 */
    	public function updateColumns(DataContainer $dc)	{

            $this->Database = Database::getInstance();

    		if($dc->activeRecord->type != 'formColsStart' || $dc->activeRecord->column_name == '') {
    			return '';
    		}

    		$objModule = $this->Database->prepare("SELECT * FROM tl_form_field WHERE id=?")
                                    ->limit(1)
                                    ->execute($dc->id);

            // If column_parent doesnt match the object id fix relation
            // This happens if ptable got copied and no oncopy callback was called
            // look here
            //if($objModule->column_parent != $objModule->id) {
    		//	$this->updateColumnsRelation($objModule->pid);
            //}

    		$column_amount = $objModule->column_amount;
    		$column_sizes = $objModule->column_sizes;


    		$column_amountet_xs = $objModule->columns_xs;
    		$column_amountet_sm = $objModule->columns_sm;
    		$column_amountet_md = $objModule->columns_md;
    		$column_amountet_lg = $objModule->columns_lg;
    		$column_amountet_xl = $objModule->columns_xl;

    		//foreach(unserialize($column_sizes) as $size) {
    		//	//$colSetSizes .= ',columns_' . $size;
    		//	$column_amountet_xl = $objModule->columns_xl;
    		//
    		//	$this->log('Sizes: ' . $size, 'SpaltensetHilfe createColset()', TL_ACCESS);
    		//}


    		$column_column_expert = $objModule->column_expert;

    		$arrChilds = $dc->activeRecord->column_childs != "" ? unserialize($dc->activeRecord->column_childs) : "";

    		return $this->createColset($dc->activeRecord,$column_amount,$column_sizes,$column_amountet_xs,$column_amountet_sm,$column_amountet_md,$column_amountet_lg,$column_amountet_xl,$column_column_expert,$arrChilds);

    	}
    	private function createColset($objElement,$column_amount,$column_sizes,$column_amountet_xs,$column_amountet_sm,$column_amountet_md,$column_amountet_lg,$column_amountet_xl,$column_column_expert,$arrChilds='') {
    		$intColcount = $column_amount - 2;

    		//$this->log('Create new colset with ID: ' . $objElement->id, 'SpaltensetHilfe createColset()', TL_ACCESS);

    		/* ************************** */
    		/* Neues Spaltenset anlegen */
    		/* ************************** */
    		if($arrChilds=='') {
    			$arrChilds = array();
                //$this->moveRows($objElement->pid,$objElement->ptable,$objElement->sorting,128 * ( $column_amount + 1 ));
                $this->moveRows($objElement->pid,$objElement->sorting,128 * ( $column_amount + 1 ));

    			$arrSet = array('pid' => $objElement->pid,
                                //'ptable' => $objElement->ptable,
    							'tstamp' => time(),
    							'sorting'=>0,
    							'type' => 'formColsPart',
    							'column_name'=> '',
    							'column_amount'=>$column_amount,
    							'column_sizes'=>$column_sizes,
    							'columns_xs'=>$column_amountet_xs,
    							'columns_sm'=>$column_amountet_sm,
    							'columns_md'=>$column_amountet_md,
    							'columns_lg'=>$column_amountet_lg,
    							'columns_xl'=>$column_amountet_xl,
    							'column_expert'=>$column_column_expert,
    							'column_parent'=>$objElement->id,
    							'column_sortid'=>0,
    							'column_gap' => $objElement->column_gap,
    							'column_usecustomgap' => $objElement->column_usecustomgap,
    							'column_color' => $objElement->column_color
    							);
                # look here
                //if(in_array('GlobalContentelements',$this->Config->getActiveModules()))
                //{
                //    $arrSet['do'] = $this->Input->get('do');
                //}

    			for($i=1;$i<=$intColcount+1;$i++)
    			{

    				$arrSet['sorting'] = $objElement->sorting+($i+1)*64;
    				$arrSet['column_name'] = $objElement->column_name.'-Part-'.($i);
    				$arrSet['column_sortid'] = $i;

    				$insertElement = $this->Database->prepare("INSERT INTO tl_form_field %s")
    												->set($arrSet)
    												->execute()
    												->insertId;

    				$arrChilds[] = $insertElement;
    			}

    			$arrSet['sorting'] = $objElement->sorting+($i+1)*64;
    			$arrSet['type'] = 'formColsEnd';
    			$arrSet['column_name'] = $objElement->column_name.'-End';
    			$arrSet['column_sortid'] = $intColcount+2;

    			$insertElement = $this->Database->prepare("INSERT INTO tl_form_field %s")
    											->set($arrSet)
    											->execute()
    											->insertId;

    			$arrChilds[] = $insertElement;

    			$insertElement = $this->Database->prepare("UPDATE tl_form_field %s WHERE id=?")
    											->set(array('column_childs'=>$arrChilds,'column_parent'=>$objElement->id,))
    											->execute($objElement->id);

    			return true;

    		}

    		/* ************************** */
    		/* Gleiche Spaltenzahl */
    		/* ************************** */
    		if(count($arrChilds) == $column_amount) {
    			$intLastElement = array_pop($arrChilds);

    			$i = 1;
    			foreach($arrChilds as $v)
    			{
    				$arrSet = array(
    								'column_amount'=>$column_amount,
    								'column_sizes'=>$column_sizes,
    								'columns_xs'=>$column_amountet_xs,
    								'columns_sm'=>$column_amountet_sm,
    								'columns_md'=>$column_amountet_md,
    								'columns_lg'=>$column_amountet_lg,
    								'columns_xl'=>$column_amountet_xl,
    								'column_expert'=>$column_column_expert,
    								'column_gap' => $objElement->column_gap,
    								'column_usecustomgap' => $objElement->column_usecustomgap,
    								'column_sortid' => $i,
    								'column_name' => $objElement->column_name.'-Part-'.($i++),
    								'column_color' => $objElement->column_color

    				);

    				$this->Database->prepare("UPDATE tl_form_field %s WHERE id=".$v)
    											->set($arrSet)
    											->execute();
    			}

    			$arrSet = array(
    							'column_amount'=>$column_amount,
    							'column_sizes'=>$column_sizes,
    							'columns_xs'=>$column_amountet_xs,
    							'columns_sm'=>$column_amountet_sm,
    							'columns_md'=>$column_amountet_md,
    							'columns_lg'=>$column_amountet_lg,
    							'columns_xl'=>$column_amountet_xl,
    							'column_expert'=>$column_column_expert,
    							'column_gap' => $objElement->column_gap,
    							'column_sortid' => $i,
    							'column_name' => $objElement->column_name.'-End',
                                'column_color' => $objElement->column_color
    			);

    			$this->Database->prepare("UPDATE tl_form_field %s WHERE id=".$intLastElement)
    										->set($arrSet)
    										->execute();

    			return true;

    		}

    		/* ************************** */
    		/* Weniger Spalten */
    		/* ************************** */
    		if(count($arrChilds) > $column_amount) {
    			$intDiff = count($arrChilds) - $column_amount;

    			for($i=1;$i<=$intDiff;$i++)
    			{
    				$intChildId = array_pop($arrChilds);
    				$this->Database->prepare("DELETE FROM tl_form_field WHERE id=?")
    											->execute($intChildId);
    			}

    			$this->Database->prepare("UPDATE tl_form_field %s WHERE id=?")
    											->set(array('column_childs'=>$arrChilds))
    											->execute($objElement->id);

    			/* Andere Daten im Colset anpassen - Spaltenabstand und SpaltenSet-Typ */
    			$arrSet = array(
    							'column_amount'=>$column_amount,
    							'column_sizes'=>$column_sizes,
    							'columns_xs'=>$column_amountet_xs,
    							'columns_sm'=>$column_amountet_sm,
    							'columns_md'=>$column_amountet_md,
    							'columns_lg'=>$column_amountet_lg,
    							'columns_xl'=>$column_amountet_xl,
    							'column_expert'=>$column_column_expert,
    							'column_gap' => $objElement->column_gap,
    							'column_usecustomgap' => $objElement->column_usecustomgap,
    							'column_color' => $objElement->column_color
    							);

    			foreach($arrChilds as $value)
    			{

    				$this->Database->prepare("UPDATE tl_form_field %s WHERE id=?")
    											->set($arrSet)
    											->execute($value);

    			}

    			/*  Den Typ des letzten Elements auf End-ELement umsetzen und FSC-namen anpassen */
    			$intChildId = array_pop($arrChilds);

    			$arrSet['column_name'] = $objElement->column_name.'-End';
    			$arrSet['type'] = 'formColsEnd';

    			$this->Database->prepare("UPDATE tl_form_field %s WHERE id=?")
    											->set($arrSet)
    											->execute($intChildId);

    			return true;
    		}

    		/* ************************** */
    		/* Mehr Spalten */
    		/* ************************** */
    		if(count($arrChilds) < $column_amount) {
    			$intDiff = $column_amount - count($arrChilds);

    			$objEnd = $this->Database->prepare("SELECT id,sorting,column_sortid FROM tl_form_field WHERE id=?")->execute($arrChilds[count($arrChilds)-1]);

                //$this->moveRows($objElement->pid,$objElement->ptable,$objEnd->sorting,64 * ( $intDiff) );
                $this->moveRows($objElement->pid,$objEnd->sorting,64 * ( $intDiff) );

    			/*  Den Typ des letzten Elements auf End-ELement umsetzen und SC-namen anpassen */
    			$intChildId	= count($arrChilds);
    			$arrSet['column_name'] = $objElement->column_name.'-Part-'.($intChildId);
    			$arrSet['type'] = 'formColsPart';

    			$this->Database->prepare("UPDATE tl_form_field %s WHERE id=?")
    											->set($arrSet)
    											->execute($objEnd->id);



    			$intFscSortId = $objEnd->column_sortid;
    			$intSorting = $objEnd->sorting;

    			$arrSet = array('type' => 'formColsPart',
    							'pid' => $objElement->pid,
                                //'ptable' => $objElement->ptable,
    							'tstamp' => time(),
    							'sorting' => 0,
    							'column_name' => '',
    							'column_amount'=>$column_amount,
    							'column_sizes'=>$column_sizes,
    							'columns_xs'=>$column_amountet_xs,
    							'columns_sm'=>$column_amountet_sm,
    							'columns_md'=>$column_amountet_md,
    							'columns_lg'=>$column_amountet_lg,
    							'columns_xl'=>$column_amountet_xl,
    							'column_expert'=>$column_column_expert,
    							'column_parent' => $objElement->id,
    							'column_sortid' => 0,
    							'column_gap' => $objElement->column_gap,
    							'column_usecustomgap' => $objElement->column_usecustomgap,
    							'column_color' => $objElement->column_color
    							);
                # look here
                //if(in_array('GlobalContentelements',$this->Config->getActiveModules()))
                //{
                //    $arrSet['do'] = $this->Input->get('do');
                //}

    			if($intDiff>0)
    			{

    				/* Andere Daten im Colset anpassen - Spaltenabstand und SpaltenSet-Typ */
    				for($i=1;$i<$intDiff;$i++)
    				{
    					++$intChildId;
    					++$intFscSortId;
    					$intSorting += 64;
    					$arrSet['column_name'] = $objElement->column_name.'-Part-'.($intChildId);
    					$arrSet['column_sortid'] = $intFscSortId;
    					$arrSet['sorting'] = $intSorting;

    					$objInsertElement = $this->Database->prepare("INSERT INTO tl_form_field %s")
    											->set($arrSet)
    											->execute();

    					$insertElement = $objInsertElement->insertId;

    					$arrChilds[] = $insertElement;

    				}


    			}

    			/* Andere Daten im Colset anpassen - Spaltenabstand und SpaltenSet-Typ */
    			$arrData = array(
    							'column_amount'=>$column_amount,
    							'column_sizes'=>$column_sizes,
    							'columns_xs'=>$column_amountet_xs,
    							'columns_sm'=>$column_amountet_sm,
    							'columns_md'=>$column_amountet_md,
    							'columns_lg'=>$column_amountet_lg,
    							'columns_xl'=>$column_amountet_xl,
    							'column_expert'=>$column_column_expert,
    							'column_gap' => $objElement->column_gap,
    							'column_usecustomgap' => $objElement->column_usecustomgap,
    							'column_color' => $objElement->column_color
    							);

    			foreach($arrChilds as $value)
    			{

    				$this->Database->prepare("UPDATE tl_form_field %s WHERE id=?")
    											->set($arrData)
    											->execute($value);

    			}

    			/* Neues End-element erzeugen */
    			$arrSet['sorting'] = $intSorting + 64;
    			$arrSet['type'] = 'formColsEnd';
    			$arrSet['column_name'] = $objElement->column_name.'-End';
    			$arrSet['column_sortid'] = ++$intFscSortId;

    			$insertElement = $this->Database->prepare("INSERT INTO tl_form_field %s")
    											->set($arrSet)
    											->execute()
    											->insertId;

    			$arrChilds[] = $insertElement;

    			/* Kindelemente in Startelement schreiben */
    			$insertElement = $this->Database->prepare("UPDATE tl_form_field %s WHERE id=?")
    											->set(array('column_childs'=>$arrChilds))
    											->execute($objElement->id);

    			return true;

    		}

    	}

    	public function deleteColumns(DataContainer $dc)
    	{
            $this->Database = Database::getInstance();

    		$delRecord = $this->Database->prepare("SELECT * FROM tl_form_field WHERE id=?")
    												->execute($dc->id)
    												->fetchAssoc();

    		if($delRecord['type'] == 'formColsStart' || $delRecord['type'] == 'formColsPart' || $delRecord['type'] == 'formColsEnd')
    		{

    			/**
    			 * Wird ein Startelement gelöscht, werden alle Kindelemente in ein Array geschrieben
    			 * und ebenfalls gelöscht
    			 */
    			if($delRecord['type'] == 'formColsStart') $eraseArray = $delRecord['column_childs'] != "" ? unserialize($delRecord['column_childs']) : array();

    			/**
    			 * Wird ein Teiler oder das Endelement gelöscht
    			 */
    			if($delRecord['type'] == 'formColsPart' || $delRecord['type'] == 'formColsEnd')
    			{
    				$parent = $this->Database->prepare("SELECT column_childs FROM tl_form_field WHERE id=?")
    										  ->execute($delRecord['column_parent'])
    										  ->fetchAssoc();
    				$childs = $parent['column_childs'] != "" ? unserialize($parent['column_childs']) : array();

    				$eraseArray[] = $delRecord['column_parent'];

    				foreach($childs as $wert)
    				{
    					if($wert != $delRecord['id']) $eraseArray[] = $wert;
    				}
    			}

    			if(count($eraseArray) > 0)
    			{

    				for($i = 0;$i < count($eraseArray); $i++)
    				{
    					$this->Database->prepare("DELETE FROM tl_form_field WHERE id=?")
    										  ->execute($eraseArray[$i]);
    				}

    			}

    		}

    	}

    	private function moveRows($pid,$sorting,$ammount=128)
    	{
            $this->Database = Database::getInstance();

    		$this->Database->prepare("UPDATE tl_form_field SET sorting = sorting + ? WHERE pid=? AND sorting > ?")
    									->execute($ammount,$pid,$sorting);

    	}

    	/* Toggle-Status auf Trenn und End-elemente anwenden */
    	public function toggleAdditionalElements($varValue,$dc)
    	{
            $this->Database = Database::getInstance();
    		$objEntry = $this->Database->prepare("UPDATE tl_form_field SET tstamp=". time() .", invisible='" . ( $varValue ? 1 : '') . "' WHERE column_parent=? AND type!=?")->execute($dc->id,'formColsStart');

    		return $varValue;

    	}

    	public function copyColumns($intId,DataContainer $dc)
    	{
            $this->Database = Database::getInstance();
    		$dc->activeRecord = $this->Database->prepare("SELECT * FROM tl_form_field WHERE id=?")->execute($intId)->first();

			$inputAct = htmlspecialchars(Input::get('act'));
			$table = htmlspecialchars(Input::get('table'));
			
			if($table != 'tl_form_field') {
				return;
			}

            if($dc->activeRecord->type != 'formColsStart' && $dc->activeRecord->type != 'formColsPart' && $dc->activeRecord->type != 'formColsEnd')
            {
                return;
            }

    		if($inputAct == 'copy')
    		{
    			if($dc->activeRecord->type == 'formColsStart')
    			{
    				$this->Database->prepare("UPDATE tl_form_field %s WHERE id=?")
    							->set(array('column_childs'=>''))
    							->execute($intId);
    			}
    		}

    		if($inputAct == 'copyAll')
    		{

    			// Startelement mit aktuellen Daten besetzen und Session mit alten Daten füllen
    			if($dc->activeRecord->type == 'formColsStart')
    			{

    				$arrSession = array(
    					'parentId' 	=> $intId,
    					'count'		=> 1,
    					'childs'	=> array()
    				);

    				#$this->Session->set('sc'.$dc->activeRecord->column_parent,$arrSession);
                    $GLOBALS['_tmp_columns']['column_'.$dc->activeRecord->column_parent] = $arrSession;

    				$arrSet = array(
    					'column_name'	=> 'colset.' . $intId,
    					'column_parent' => $intId
    				);

    				$this->Database->prepare("UPDATE tl_form_field %s WHERE id=?")
    											->set($arrSet)
    											->execute($intId);
    			}

    			if($dc->activeRecord->type == 'formColsPart')
    			{
    				//$arrSession = $this->Session->get('sc'.$dc->activeRecord->column_parent);
    				$arrSession = $GLOBALS['_tmp_columns']['column_'.$dc->activeRecord->column_parent];

    				$intNewParent = $arrSession['parentId'];
    				$intCount = $arrSession['count'];
    				$arrChilds = $arrSession['childs'];


    				$arrSet = array(
    					'column_name'	=> 'colset.' . $intNewParent . '-Part-' . $intCount,
    					'column_parent' => $intNewParent
    				);

    				$this->Database->prepare("UPDATE tl_form_field %s WHERE id=?")
    											->set($arrSet)
    											->execute($intId);

    				$arrChilds[] = $intId;

    				$arrSession['count'] = ++$intCount;
    				$arrSession['childs'] = $arrChilds;

    				//$this->Session->set('sc'.$dc->activeRecord->column_parent,$arrSession);
                    $GLOBALS['_tmp_columns']['column_'.$dc->activeRecord->column_parent] = $arrSession;

    			}

    			if($dc->activeRecord->type == 'formColsEnd')
    			{

    				//$arrSession = $this->Session->get('sc'.$dc->activeRecord->column_parent);
    				$arrSession = $GLOBALS['_tmp_columns']['column_'.$dc->activeRecord->column_parent];

    				$intNewParent = $arrSession['parentId'];
    				$intCount = $arrSession['count'];
    				$arrChilds = $arrSession['childs'];

    				$arrSet = array(
    					'column_name'	=> 'colset.' . $intNewParent . '-End',
    					'column_parent' => $intNewParent
    				);

    				$this->Database->prepare("UPDATE tl_form_field %s WHERE id=?")
    											->set($arrSet)
    											->execute($intId);

    				$arrChilds[] = $intId;

    				$arrSet = array(
    					'column_childs' => $arrChilds
    				);

    				$this->Database->prepare("UPDATE tl_form_field %s WHERE id=?")
    											->set($arrSet)
    											->execute($intNewParent);

    			}



    		}
    	}

    	public function updateColumnsRelation($pid)
    	{
            $this->Database = Database::getInstance();
    		$objcolsStarts = $this->Database->prepare("SELECT id,column_childs FROM tl_form_field WHERE pid=? AND type=? ORDER BY sorting")
    												->execute($pid,'formColsStart');

    		if($objcolsStarts->numRows > 0)
    		{
    			$parent = 0;
    			$childs = array();
    			$parents = array();
    			while($objcolsStarts->next())
    			{
    				$column_name = 'colset.' . $objcolsStarts->id;
    				$column_parent = $objcolsStarts->id;
    				$parent = $objcolsStarts->id;
    				$oldChilds = unserialize($objcolsStarts->column_childs);
    				$oldChildParent = $this->Database->prepare("SELECT column_parent FROM tl_form_field WHERE id=?")
    											    ->limit(1)
    												->execute($oldChilds[0]);

    				$newChilds = $this->Database->prepare("SELECT id,type FROM tl_form_field WHERE pid=? AND column_parent=? AND type != 'colsStart'")
    												->execute($pid,$oldChildParent->column_parent);
    				$i=1;
    				while($newChilds->next())
    				{
    					$childs[$parent]['column_childs'][] = $newChilds->id;
    					$parents[$newChilds->id]['column_parent'] = $parent;
    					$parents[$newChilds->id]['column_name'] = $column_name . ($newChilds->type=="formColsPart" ? '-Part-' . $i : '-End');
    					$parents[$newChilds->id]['column_sortid'] = $i;
    					$i++;
    				}
    				$childs[$parent]['column_parent'] = $column_parent;
    				$childs[$parent]['column_name'] = $column_name;
    				sort($childs[$parent]['column_childs']);

    			}

    			foreach($childs as $key=>$child)
    			{
    				$this->Database->prepare("UPDATE tl_form_field %s WHERE id=?")
    											->set(array('column_parent'=>$child['column_parent'],'column_childs'=>$child['column_childs'],'column_name'=>$child['column_name']))
    											->execute($key);
    			}

    			foreach($parents as $key=>$parent)
    			{
    				$this->Database->prepare("UPDATE tl_form_field %s WHERE id=?")
    											->set(array('column_parent'=>$parent['column_parent'],'column_name'=>$parent['column_name'],'column_sortid'=>$parent['column_sortid']))
    											->execute($key);
    			}

    		}





    	}

    	/**
         *
         * HOOK: $GLOBALS['TL_HOOKS']['clipboardCopy']
         *
         * @param integer $intId
         * @param datacontainer $dc
         * @param boolean $isGrouped
         */
        public function clipboardCopy($intId, DataContainer $dc, $isGrouped)
        {
            $this->Database = Database::getInstance();
            if(!$isGrouped) {
    			$objActiveRecord = $this->Database
                        ->prepare("SELECT * FROM tl_form_field WHERE id = ?")
                        ->executeUncached($intId);

    			if($objActiveRecord->type == 'formColsStart') {

    				$this->Database->prepare("UPDATE tl_form_field %s WHERE id=?")
                                ->set(array('column_childs'=>'','column_parent'=>'','column_name'=>'colset.'.$objActiveRecord->id))
                                ->execute($intId);

                    $objContent = $this->Database
                                ->prepare("Select * FROM tl_form_field WHERE id=?")
                                ->execute($intId);

    				$column_amount = $objContent->column_amount;
    				$column_sizes = $objContent->column_sizes;

    				$column_amountet_xs = $objContent->columns_xs;
    				$column_amountet_sm = $objContent->columns_sm;
    				$column_amountet_md = $objContent->columns_md;
    				$column_amountet_lg = $objContent->columns_lg;
    				$column_amountet_xl = $objContent->columns_xl;
    				$column_column_expert = $objContent->column_expert;

    				$arrChilds = $dc->activeRecord->column_childs != "" ? unserialize($dc->activeRecord->column_childs) : "";

    				//$this->log('Values: ec columns='.$column_amount, 'SpaltensetHilfe clipboardCopy()', __METHOD__, TL_ACCESS);

    				$this->createColset($dc->activeRecord,$column_amount,$column_sizes,$column_amountet_xs,$column_amountet_sm,$column_amountet_md,$column_amountet_lg,$column_amountet_xl,$column_column_expert,$arrChilds);

    			}
    		}

    	}
}
